package cz.muni.fi.pb162.junit;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import junit.framework.TestCase;
import junit.framework.TestResult;
import junit.framework.TestSuite;

public class PersonTestTest extends TestCase {
    
    public PersonTestTest(String name) {
	super(name);
    }

    private void runTestSuite(Class clazz, boolean expectedResult) throws
	    ClassNotFoundException, NoSuchMethodException, 
	    IllegalAccessException, InvocationTargetException {
	
	ClassLoader loader = new TestClassLoader(clazz);
	Class testClass = loader.loadClass(PersonTest.class.getName());
	TestResult result = new TestResult();
	new TestSuite(testClass).run(result);
	Method m = clazz.getDeclaredMethod("getDescription");
	assertTrue("Pri testovani tridy " + clazz.getName() + 
		(expectedResult?" doslo":" nedoslo") + " k chybe, ackoliv " +
		m.invoke(null),
		result.wasSuccessful() == expectedResult);
    }

    public void testCorrectClass() throws Exception {
	runTestSuite(PersonWithNoError.class,true);
    }

    public void testWrongConstructor1() throws Exception {
	runTestSuite(PersonWrongConstructor1.class,false);
    }
    
    public void testWrongConstructor2() throws Exception {
	runTestSuite(PersonWrongConstructor2.class,false);
    }

    public void testWrongEquals1() throws Exception {
	runTestSuite(PersonWrongEquals1.class,false);
    }

    public void testWrongEquals2() throws Exception {
	runTestSuite(PersonWrongEquals2.class,false);
    }

    public void testWrongEquals3() throws Exception {
	runTestSuite(PersonWrongEquals3.class,false);
    }

    public void testWrongEquals4() throws Exception {
	runTestSuite(PersonWrongEquals4.class,false);
    }

    public void testWrongEquals5() throws Exception {
	runTestSuite(PersonWrongEquals5.class,false);
    }

    public void testWrongEquals6() throws Exception {
	runTestSuite(PersonWrongEquals6.class,false);
    }

    public void testWrongEquals7() throws Exception {
	runTestSuite(PersonWrongEquals7.class,false);
    }

    public void testWrongHashCode1() throws Exception {
	runTestSuite(PersonWrongHashCode1.class,false);
    }
 
    public void testWrongGetAge1() throws Exception {
	runTestSuite(PersonWrongGetAge1.class,false);
    }

    public void testWrongGetAge2() throws Exception {
	runTestSuite(PersonWrongGetAge2.class,false);
    }
    
}
